CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 3
MULTIPLICA_DOBLES_PALABRAS_SIN_SIGNO:	; Procedimiento lejano
; Condicin de llamada:
;	Multiplicando (B1B0) se pasa por pila
;       Multiplicador se pasa a continuacin por pila
; Condicin de retorno:
;	Cudruple palabra de resultado por pila
; Registros usados:
;	DI para P3, SI para P2, CX para P1 y BX para P0
;	DX y AX para los productos parciales


	MOV	BP,SP
; P3, P2 Y P1 <-- 0:
	SUB	DI,DI
	SUB	SI,SI
	SUB	CX,CX		
; A0xB0:
	MOV	AX,[BP+4]
	MUL	[BP+8]
; P0 <-- palabra baja de A0xB0 y P1 <-- palabra alta de A0xB0:
	MOV	BX,AX
	MOV	CX,DX
; A0xB1:
	MOV	AX,[BP+4]
	MUL	[BP+10]
; P1 <-- P1+palabra baja de A0xB1 y P2 <-- P2+alta de A0xB1+C:
	ADD	CX,AX
	ADC	SI,DX
; A1xB0:
	MOV	AX,[BP+6]
	MUL	[BP+8]
; P1 <-- P1+palabra baja de A1xB0 y P2 <-- P2+alta de A1xB0+C:
	ADD	CX,AX
	ADC	SI,DX
; P2 <-- P2+0+C:
	ADC	DI,0
; A1xB1:
	MOV	AX,[BP+6]
	MUL	[BP+10]
; AX <-- P2+palabra baja de A1xB1 y DX <-- P3+alta de A1xB0+C:
	ADD	SI,AX
	ADC	DI,DX
; Devuelve el resultado:
	MOV	[BP+10],DI
	MOV	[BP+8],SI
	MOV	[BP+6],CX
	MOV	[BP+4],BX
	RETF

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
