CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 2
MULTIPLICA_DOBLES_PALABRAS_CON_SIGNO:
; Condicin de llamada:
;	DI:SI = Multiplicando (B1B0)
;	BX:AX = Multiplicador (A1A0)
; Condicin de retorno:
;       DI:SI:BX:AX = cudruple palabra (orden decreciente de pesos)

; P3, P2 Y P1 <-- 0:
	MOV	CS:P1,0
	MOV	CS:P2,0
	MOV	CS:P3,0
; Guarda A0:
	MOV	CX,AX
; A0xB0:
	MUL	SI
; P0 <-- palabra baja de A0xB0 y P1 <-- palabra alta de A0xB0:
	MOV	CS:P0,AX
	MOV	CS:P1,DX
; A0xB1:
	MOV	AX,CX
	IMUL	DI
; P1 <-- P1+palabra baja de A0xB1 y P2 <-- P2+alta de A0xB1+C:
	ADD	CS:P1,AX
	ADC	CS:P2,DX
; Acumular la extensin de signo:
	XCHG	AX,DX
	CWD
	ADD	CS:P3,DX	
; Ver si hay que hacer correccin:
	TEST	CX,8000h
;     S:
	JNS	SIGUE
	ADD	CS:P2,DI
	MOV	AX,DI		; no afecta a la bandera de acarreo
	CWD			; no afecta a la bandera de acarreo
        ADC     CS:P3,DX        ; se acumula el acarreo y la extensin
SIGUE:
; A1xB0:
	MOV	AX,BX
	IMUL	SI
; P1 <-- P1+palabra baja de A1xB0 y P2 <-- P2+alta de A1xB0+C:
	ADD	CS:P1,AX
	ADC	CS:P2,DX
; P3 <-- P3+extensin de signo +C:
	XCHG	AX,DX
	CWD
	ADC	CS:P3,DX
; Ver si hay que hacer correccin:
	TEST	SI,8000h
;     S:
	JNS	SIGUE2
	ADD	CS:P2,BX
	MOV	AX,BX		; no afecta a la bandera de acarreo
	CWD			; no afecta a la bandera de acarreo
        ADC     CS:P3,DX        ; se acumula el acarreo y la extensin
SIGUE2:
; A1xB1:
	MOV	AX,BX
	IMUL	DI
; P2 <-- P2+palabra baja de A1xB1 y P3 <-- P3+alta de A1xB0+C:
	ADD	CS:P2,AX
	ADC	CS:P3,DX
; Devuelve el resultado:
	MOV	DI,CS:P3
	MOV	SI,CS:P2
	MOV	BX,CS:P1
	MOV	AX,CS:P0
	RET

	EVEN
P0	DW	?
P1	DW	?
P2	DW	?
P3	DW	?

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
