; Procedimiento para multiplicar dos matrices  A y B: (M,N)x(N,P)
; Versin 2

CODIGO  SEGMENT
        ASSUME  CS:CODIGO

PARAMETROS	STRUC
DIR_RETORNO	DD	?
P		DW	?
N		DW	?
M		DW	?
SEGMENTO_C	DW	?
SEGMENTO_B	DW	?
SEGMENTO_A	DW	?
PARAMETROS	ENDS
ENTRADA PROC    FAR

; Multiplica matrices: A(M,N) x B(N,P)=C(M,P), de datos octeto
; OJO --> No se guarda contexto

MULTI_MATRI:
	MOV	BP,SP
	MOV	AX,[BP].P
        MUL     [BP].P
	MOV	CS:N_POR_P,AX	; se asume que DX=0 siempre	
	MOV	AX,[BP].M
       	MOV	CS:CONTADOR_M,AX
	MOV	ES,[BP].SEGMENTO_B
	MOV	DS,[BP].SEGMENTO_A
	SUB	SI,SI
	SUB	DI,DI
	CLD
        SUB     SI,[BP].N
BUCLE_EXTERNO:
        ADD     SI,[BP].N
	MOV	AX,[BP].P
	MOV	CS:CONTADOR_P,AX
	DEC	BX
BUCLE_MEDIO:
	INC	BX
	SUB	DX,DX
	MOV	CX,[BP].N
BUCLE_INTERNO:
	LODSB
	MUL	BYTE PTR ES:[BX]	; se asume que AH siempre =0
	ADD	DX,AX			; se asume que nunca hay acarreo
	ADD	BX,[BP].P
	LOOP	BUCLE_INTERNO
	PUSH	ES
	MOV	ES,[BP].SEGMENTO_C
	MOV	AX,DX
	STOSW
	POP	ES
	SUB	SI,[BP].N
	SUB	BX,CS:N_POR_P
	DEC	CS:CONTADOR_P
	JNZ	BUCLE_MEDIO
	DEC	CS:CONTADOR_M
	JNZ	BUCLE_EXTERNO
	RETF	6*2		; se retiran 6 parmetros tipo palabra

	EVEN
CONTADOR_M	DW	?
CONTADOR_P	DW	?
N_POR_P	DW	?

ENTRADA	ENDP
CODIGO  ENDS
        END ENTRADA
