; Ordenacin de una lista de diez octetos almacenados a partir de la direccin
; lgica 38F6:2000h. Criterio de ordenacin: de menor a mayor.
; Versin 1
SEGMENTO	EQU	38F6h
LISTA		EQU	2000h
NUMERO_DAT	EQU	10
AFIRMATIVO      EQU     1 ; no se usa el smbolo SI para evitar confusin.
NO		EQU	0

ORDENA_LISTA:
EMPIEZA:        MOV     CS:CAMBIO,NO     ;iniciacin de variables
		MOV	CS:CONTADOR,0
                MOV     BX,SEGMENTO      ;iniciacin del segmento de datos
		MOV	DS,BX
                MOV     BX,OFFSET LISTA  ;iniciacin del puntero a la LISTA
SIGUIENTE_PAREJA:	
		MOV	AL,[BX]		; toma primer dato de una pareja
                CMP     AL,[BX+1]       ; est ordenado resp. al segundo?
                JBE     SIGUE               ; si: pues sigue a la siguiente
                MOV     AH,[BX+1]           ; no: intercambiarlos
		MOV	[BX],AH
		MOV	[BX+1]AL
                MOV     CS:CAMBIO,AFIRMATIVO  ; marcar que se ha hecho cambio
SIGUE:          ADD     BX,1                  ; apuntar a la siguiente pareja
                INC     CS:CONTADOR           ; quedan parejas?
		CMP	CS:CONTADOR, NUMERO_DAT-1	
                JNE     SIGUIENTE_PAREJA       ; si: ir por ella
                CMP     CS:CAMBIO, AFIRMATIVO  ; no: se ha hecho...
                JE      EMPIEZA            ; algn cambio? SI: iterar barrido
                RET                        ;               NO: retornar
CAMBIO          DW      ?
CONTADOR	DW	?
