; Ordenacin de una lista de diez octetos almacenados a partir de la direccin
; lgica 38F6:2000h. Criterio de ordenacin: de menor a mayor.
; Versin 7
SEGMENTO	EQU	38F6h
LISTA		EQU	2000h
NUMERO_DAT	EQU	10
AFIRMATIVO      EQU     1 ; no se usa el smbolo SI para evitar confusin.
NO		EQU	0

ORDENA_LISTA:   MOV     BX,SEGMENTO     
		MOV	DS,BX
                MOV     SI, NUMERO_DAT ;SI indica el nmero de parejas + 1

;iniciacin de variables:
OTRA_PASADA:
                DEC     SI              ; una pareja menos
                SUB     DL,DL           ; CAMBIO <-- NO     
                MOV     CX,SI           ; CONTADOR <-- nmero de parejas

;iniciacin del puntero BX para que apunte al inicio de la LISTA:
                MOV     BX,OFFSET LISTA
; Evala pareja:
SIGUIENTE_PAREJA:	
		MOV	AL,[BX]		

; estn ordenados?
		CMP	AL,[BX+1]		
		JBE	SIGUE		

; NO: hay que intercambiarlos, e indicar que se ha hecho cambio:
		XCHG	AL,[BX+1]		
		MOV	[BX],AL
		MOV	DL,AFIRMATIVO

SIGUE:          INC     BX               
		LOOP	SIGUIENTE_PAREJA		
		CMP	DL, AFIRMATIVO   	
		JE	OTRA_PASADA	      
		RET			  	
