; Ordenacin de una lista de diez octetos almacenados a partir de la direccin
; lgica 38F6:2000h. Criterio de ordenacin: de menor a mayor.
; Versin 9
SEGMENTO	EQU	38F6h
LISTA		EQU	2000h
NUMERO_DAT	EQU	10
AFIRMATIVO	EQU	0 
NO		EQU	1

ORDENA_LISTA:
		MOV	BX,SEGMENTO     
		MOV	DS,BX
                MOV     SI, NUMERO_DAT ;SI indica el nmero de parejas + 1

;iniciacin de variables:
OTRA_PASADA:    DEC     SI                  ; una pareja menos
                MOV     AL,NO               ; CAMBIO <-- NO     
                MOV     CX,SI               ; CONTADOR <-- nmero de parejas

;iniciacin del puntero BX para que apunte al inicio de la LISTA:
                MOV     BX,OFFSET LISTA
; Evala pareja:
SIGUIENTE_PAREJA:	
		MOV	AH,[BX]		

; estn ordenados?
		CMP	AH,[BX+1]		
		JBE	SIGUE		

; NO: hay que intercambiarlos, e indicar que se ha hecho cambio:
		XCHG	AH,[BX+1]		
		MOV	[BX],AH
		SUB	AL,AL		; CAMBIO <-- SI

; preparar siguiente pareja:
SIGUE:          INC     BX       

; quedan ms parejas? 
                LOOP    SIGUIENTE_PAREJA     ; si: tomar siguiente pareja

; No: se ha hecho algn cambio?  
		DEC	AL		
                JNZ     OTRA_PASADA          ; s: iterar un nuevo barrido
                RET                          ; no: lista ordenada, retornar
