CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 1b 
GIRADO_DE_IMAGEN_EJE_VERTICAL:
        MOV     CX,DX           ; factor de iteracin del bucle externo
	MOV	BX,AX
	SHR	BX,1
        MOV     CS:FACTOR_ITERACION_INTERNO,BX
GIRA_OTRA_FILA:
        MOV     BX,AX           ; BX <-- ancho de lnea
	PUSH	SI		; guarda inicio de la fila
	PUSH	CX		; guarda contexto del bucle externo
	MOV	CX,CS:FACTOR_ITERACION_INTERNO
GIRA_FILA:	
        MOV     DX,[SI+BX-2]    ; toma pareja de datos a la derecha
	XCHG	DL,DH		; girarlos
        XCHG    DX,[SI]         ; intercambiarla con la de la izquierda
	XCHG	DL,DH		; tras girarla se deja en el 
        MOV     [SI+BX-2],DX    ; extremo de la derecha
        ADD     SI,2            ; apunta a las prximas pareja: derecha
	SUB	BX,4		; e izquierda
        LOOP    GIRA_FILA       ; quedan pxeles en la lnea por girar?
        POPF                    ;   no: pero antes ver si queda una
        JNC     SIGUE           ;       pareja central
        MOV     DX,[SI]         ;   queda: girarla
	XCHG	DL,DH
	MOV	[SI],DX
SIGUE:	POP	CX		; restaura el contexto del bucle externo
        POP     SI              ; recupera el inicio de la lnea
	ADD	SI,AX		; apunta al inicio de la siguiente
        LOOP    GIRA_OTRA_FILA  ; quedan lneas por girar?
	RET				; no: FIN
	EVEN
FACTOR_ITERACION_INTERNO DW ?

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
