CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 2b (imagen con anchura par de lneas)
GIRADO_DE_IMAGEN_EJE_VERTICAL:
        MOV     CX,DX           ; factor de iteracin del bucle externo
	MOV	BX,AX
	SHR	BX,1
	SHR	BX,1
	MOV	CS:PIXELES_SUELTO,0
	MOV	CS:FACTOR_ITERACIN_INTERNO
	JNC	GIRA_OTRA_FILA
	MOV	CS_PIXELES_SUELTOS,1
GIRA_OTRA_FILA:
        MOV     BX,AX           ; BX <-- ancho de lnea
	PUSH	SI		; guarda inicio de la fila
	PUSH	CX		; guarda contexto del bucle externo
	MOV	CX,CS:FACTOR_ITERACION_INTERNO
GIRA_FILA:	MOV	DX,[SI+BX-2] ; toma pareja de datos a la derecha
	XCHG	DL,DH		; girarlos
        XCHG    DX,[SI]         ; intercambiarla con la de la izquierda
	XCHG	DL,DH		; tras girarla se deja en el 
	MOV	[SI+BX-2],DX ; extremo de la derecha
        ADD     SI,2            ; apunta a las prximas pareja: derecha
	SUB	BX,4		; e izquierda
        LOOP    GIRA_FILA       ; quedan pxeles en la lnea por girar?
	CMP 	CS:PIXELES_SUELTOS,1	; sustituye a  POPF
	JNE	SIGUE			; sustituye a JNC
	MOV	DX,[SI]	;   queda: girarla
	XCHG	DL,DH
	MOV	[SI],DX
SIGUE:	POP	CX		; restaura el contexto del bucle externo
        POP     SI              ; recupera el inicio de la lnea
	ADD	SI,AX		; apunta al inicio de la siguiente
        LOOP    GIRA_OTRA_FILA  ; quedan lneas por girar?
	RET				; no: FIN
	EVEN
FACTOR_ITERACIN_INTRENO DW ?
PIXELES_SUELTOS	DB ? 
ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
