COMMENT *
====================================================================
=                                                                  =
=            PROCEDIMIENTO QUE SUMA DATOS DE 'N' PALABRAS          =
=                            Versin 14                            =
====================================================================

Condicin de entrada: 
AX contendr el segmento en que se hallan los datos
BX es el desplazamiento del primer dato dentro del segmento especificado
CX = nmero de palabras de palabras de cada dato

Condicin de salida: 
        El resultado est en DS:BX
 	La bandera de acarreo indica si ha habido o no acarreo en la suma.*

Registros modificados:

SUMA_N_DUPLAS_PALABRAS:
		MOV	DS,AX			; inicia segmento
; SI = desplazamiento del segundo dato respecto del primero (CX x 2):
                MOV     SI,CX 
                SHL     SI,1
; guarda el inicio del resultado (el del segundo sumando, p.ej.):
                MOV     AX,BX
                ADD     AX,SI
                PUSH    AX       

; se parte de acarreo a cero
                CLC                      
SUMA_SIGUIENTE:
                MOV     AX,[BX]
                ADC     [BX+SI],AX        ; [BX+SI] apunta al sumando de B
		ADD	BX,2
                LOOP    SUMA_SIGUIENTE
                POP     BX
                RET

