CODIGO  SEGMENT
        ASSUME  CS:CODIGO
EJ4_1   PROC    FAR

SUMA_N_DUPLAS_PALABRAS_CON_SIGNO:       ; Versin 1
	MOV	DS,AX			; inicia segmento
; SI = desplazamiento del segundo dato respecto del primero (CX x 2):
	MOV	BX,CX	
	SHL	BX,1
; guarda el inicio del resultado (el del segundo sumando):
	MOV	AX,SI
	ADD	AX,BX
	PUSH	AX		
; BX <-- BX - 2 para compensar el incremento del ndice SI tras LODSW:
	SUB	BX,2
; ver si los datos son del mismo signo:
        PUSH    SI              ; guarda ndice inicial para dato B
;     comprueba el bit de signo de el dato A:
	TEST	WORD PTR [BX+SI],8000h
	JZ	A_ES_POSITIVO
;     apunta a la palabra con el signo del dato B
	ADD	SI,CX		
	ADD	SI,CX
        TEST    WORD  PTR [BX+SI],8000h         ; comprueba su signo
	JZ	A_Y_B_SON_DE_DISTINTO_SIGNO
A_Y_B_SON_NEGATIVOS:
	MOV	DL,1
	JMP	SHORT  CONTINUA
A_Y_B_SON_DE_DISTINTO_SIGNO:
	SUB	DL,DL
	JMP	SHORT  CONTINUA
A_ES_POSITIVO:
; apunta a la palabra con el signo del dato B
	ADD	SI,CX	
	ADD	SI,CX
        TEST    WORD PTR [BX+SI],8000h
	JNZ	A_Y_B_SON_DE_DISTINTO_SIGNO
A_Y_B_SON_POSITIVOS:
	MOV	DL,2
CONTINUA:
        POP     SI             ; restaura ndice  inicial para dato B
; se parte de acarreo a cero
	CLC				
SUMA_SIGUIENTE:
	LODSW		; SI queda apuntando al siguiente sumando B	
	ADC	[BX+SI],AX		; [SI+BP] apunta al sumando de B
	LOOP	SUMA_SIGUIENTE
; al sumar ya queda en la pila  el resultado
; signos de los datos?
	CMP	DL,0
	JNE	IGUALES
DISTINTOS:	CLC
        JMP     SHORT  CORRECTO 
IGUALES:	
; comprueba signo del resultado
        TEST    WORD PTR [BX+SI],8000h
	JNZ	SUMA_NEGATIVA
SUMA_POSITIVA:
	CMP	DL,2
	JE	CORRECTO
	STC
        JMP      SHORT CORRECTO 
SUMA_NEGATIVA:
	CMP	DL,1
	JE	CORRECTO
	STC
CORRECTO:	POP	BX
	RET

EJ4_1   ENDP
CODIGO  ENDS
        END 
