; Versin 5
; AX:BX indica la direccin del minuendo, y a continuacin est el
;       desplazamiento del sustraendo
; CX indica el nmero de palabras de los datos


RESTA_N_DUPLAS_PALABRAS:
        MOV     DS,AX                   ; inicia segmento
; BX = desplazamiento del sustraendo (CX x 2):
        MOV     BX,CX 
        SHL     BX,1
; guarda el inicio del resultado (el del segundo sumando):
        MOV     AX,SI
        ADD     AX,BX
        PUSH    AX       
; BX <-- BX - 2 para compensar el incremento del ndice SI tras LODSW:
        SUB     BX,2
; ver si los datos son del mismo signo:
        SUB     DL,DL           ; marcar DL como signos distintos
        PUSH    SI              ; guarda ndice inicial para dato A
        MOV     AX,[BX+SI]      ; toma palabra con signo de A
        ADD     SI,CX    ; apunta a la palabra con el signo del dato B
        ADD     SI,CX
        XOR     [BX+SI] ; contrasta signos
        JS      CONTINUA        ; signos  distintos
        MOV     DL,1            ; marcar DL como signos iguales
CONTINUA:
        POP     SI              ; restaura ndice  inicial para dato A
        CLC                     ; se parte de acarreo a cero
SUMA_SIGUIENTE:
        LODSW                   ; SI queda apuntando al siguiente sumando A 
        SBB     [BX+SI],AX      ; [SI+BP] apunta al sustraendo de B
        LOOP    SUMA_SIGUIENTE
; al sumar ya queda en la pila  el resultado.  signos de los datos?
        DEC     DL                      ; mejor usar DEC DL que CMP DL,1 
        JZ      IGUALES
DISTINTOS:	
; ver si el signo del resultado es igual al del minuendo:
        MOV     AX,[SI-2]
        XOR     AX,[BX+SI]
        JNS     CORRECTO

; es distinto al del minuendo; el resultado es incorrecto debido al rebosamiento:
        STC
        RET
CORRECTO:	
IGUALES:
	CLC
        POP     BX
        RET
