CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR

BORRA _PANTALLA:
ESPACIO		EQU	20h
ATRIBUTO	EQU	07h
PATRON_DE_BORRADO	EQU	(ATRIBUTO SHL 8)+ESPACIO
SEGMENTO_DE_VIDEO	EQU	0B800h
FILAS		EQU	25
COLUMNAS	EQU	80

; inicia el segmento de datos con el segmento de la pantalla:
	MOV	AX,SEGMENTO_DE_VIDEO
	MOV	DS,AX

; inicia las variables:
	MOV	AH,COLUMNAS*2		; equivale a MOV AH,160
	MOV	BX,PATRON_DE_BORRADO	; equivale a MOV BX,0720h
	MOV	DX,FILAS

;  bucle externo; borrar filas:

BORRA_OTRA_FILA:
; calcular inicio de la fila a borrar = fila actual x (80x2)
; fila actual = 25-DL (DH siempre vale 0)
; cada fila ocupa en memoria 160 posiciones =  80 elementos por dos
; posiciones cada elemento:
	MOV	AL,FILAS			; equivale a MOV AL,25
	SUB	AL,DL
	MUL	AH
	MOV	SI,AX
; iniciar el contador de iteraciones  del bucle interno:
	MOV	CX,COLUMNAS

; bucle interno: borrar elementos de una fila:
BORRA_OTRO_ELEMENTO_DE_LA_FILA:
	MOV	[SI],BX
	ADD	SI,2
	LOOP	BORRA_OTRO_ELEMENTO_DE_LA_FILA
	DEC	DX
	JNZ	BORRA_OTRA_FILA
	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
