CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
TRASLADA_BLOQUE:                ; Versin 2
; Descripcin: Rutina para el traslado intrasegmento de un bloque.
; Condicin de entrada:
; 	AX: segmento de origen y destino
;	SI: inicio del bloque
;	DI: inicio del destino
;       CX:  tamao del bloque a trasladar

	MOV	DS,AX		; inicia segmentos: datos para fuente
	MOV	ES,AX		; y extra para el destino
; Comprobar si el destino est entre los lmites del bloque:
	CMP	SI,DI
	JAE	RECORRIDO_ASCENDENTE2
	ADD	SI,CX		; SI <-- final del bloque
	CMP	SI,DI
	JBE	RECORRIDO_ASCENDENTE
RECORRIDO_DESCENDENTE:
	ADD	DI,CX		; DI <-- final del destino
	DEC	SI		; corrige los punteros
	DEC	DI
        STD                     ; modo decremental de los ndices
	JMP	SHORT TRASLADA
RECORRIDO_ASCENDENTE:
	SUB	SI,CX		; restaura SI con el inicio del bloque
RECORRIDO_ASCENDENTE2:
        CLD                     ; modo incremental de los ndices
TRASLADA:	
	REP MOVSB
	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
