CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
BUSCA_CADENA:           ; Versin 2
        MOV     DS,AX
        MOV     ES,DX
        MOV     CS:LONGITUD_CADENA,BX
        MOV     CS:INICIO_CADENA,SI
; Corrige el tamao del bloque (=tamao del bloque-tamao cadena+1):
        SUB     CX,BX
        INC     CX
TOMA_INICIO_DE_CADENA:
; Toma el primer dato de la cadena y...
        MOV     AL,[SI]
AVANZA_EN_EL_BLOQUE:
; ... compara con dato del bloque:
        CMP     AL,ES:[DI]
; son iguales?
        JE      INICIO_ENCONTRADO
;   No: avanza  en el bloque...
        INC     DI
;      quedan datos en el bloque?
        LOOP    AVANZA_EN_EL_BLOQUE
;       No: no  se ha encontrado:
        CLC
        RET

; S que son iguales:
INICIO_ENCONTRADO:
; guardar la direccin de concordancia:
        MOV     BP,DI 
SIGUE_CON_RESTO_DE_CADENA:
; avanza en el bloque:
        INC     DI
; queda cadena?
        DEC     BX
        JZ      ENCONTRADA              ; No: cadena encontrada
;      S que queda; tomar siguiente de la cadena:
AVANZA_LA_CADENA:
        INC     SI
        MOV     AL,[SI]
; compararlo con el siguiente del bloque:
        CMP     AL,ES:[DI]
; son iguales?
        JE      SIGUE_CON_RESTO_DE_CADENA
; No: retroceder en el bloque (y empezar la cadena)
        LEA     DI,[BP+1]
        MOV     BX,CS:LONGITUD_CADENA
        MOV     SI,CS:INICIO_CADENA
        LOOP TOMA_INICIO_DE_CADENA
        CLC
        RET
ENCONTRADA:
	STC
        RET

EVEN
INICIO_CADENA 	DW 	?
LONGITUD_CADENA DW      ?

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
