; Procedimiento para transmitir DX:CX datos octetos de manera
; paralela asncrona, ubicados a partir de la direccin lgica AX:SI
;
PUERTO_A	EQU	60h
PUERTO_C	EQU	62h

CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR

TRANSMITE:MOV	DS,AX
	CLD
	INC	DX
OTRO_DATO:
	DEC	DX
; Esperar a que el reconocimiento se inactive:
ESP_NO_RECO:	
	IN	AL,PUERTO_C
	TEST	AL,00000001b
	JZ	ESP_NO_RECO
; Tomar dato (y apuntar al siguiente):
SIGUIENTE:	
	CMP	SI,0FFFFh
	JE	SEGMENTAR
TOMA_DATO:
	LODSB
; Emitirlo:
	OUT	PUERTO_A,AL
; Validarlo:
	IN	AL,PUERTO_C
	AND	AL,11101111b
	OUT	PUERTO_C,AL
; Espera reconocimiento:
ESP_RECO:IN     AL,PUERTO_C
	TEST	AL,00000001b
	JNZ	ESP_RECO
; Desactivar la validadcin:
        IN      AL,DX
	OR	AL,00010000b
	OUT	PUERTO_C,AL
; Ver si quedan ms datos:
	LOOP	ESP_NO_RECO
	CMP	DX,0
	JNE	OTRO_DATO
FIN:	RET
SEGMENTAR:
	MOV	AX,DS
	ADD	AX,1000h
	MOV	DS,AX
	JMP	SHORT TOMA_DATO
ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
