CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 4
PON_DEL_REVES:
; Condicin de llamada: en DX:BX la direccin lgica de la cadena
;                                en CX el nmero de palabras de la cadena
; Condicin de salida: la cadena original ha sido puesta del revs, 
;				en DX:BX
; Comentario: Para acceder a una palabra se usa [BX] y  para la
;             homloga del extremo opuesto con [BX+SI]

        PUSH    DS              ; guarda contexto y direccin de cadena
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	SI
; Inicia segmento:
	MOV	DS,DX
; Inicia ndice para acceder a palabra opuesta (SI <-- (CX x 2)-2:
	MOV	SI,CX
	ADD	SI,SI
	SUB	SI,2
; Divide por 2 el nmero de palabras (factor de iteracin del bucle):
	SHR	CX,1
; Es una cadena de slo una palabra?
	JCXZ	CADENA_SOLO_ES_UNA_PALABRA
; No. Guarda el resto (en el acarreo):
	PUSHF
; Toma palabra:
OTRA_PALABRA:
	MOV	AX,[BX]
; Ponerla del revs:
	CALL	PON_DEL_REVES_PALABRA_EN_AX
; Ponerla en el extremo homlogo y tomar la palabra de ese extremo..:
	XCHG	[BX+SI],AX
; ...ponerla del revs...:
	CALL	PON_DEL_REVES_PALABRA_EN_AX
; ...y dejarla en el otro extremo homlogo:
	MOV	[BX],AX
; Apuntar a la siguiente palabra
	ADD	BX,2
; Apuntar al su extremo homlogo simtrico:
	SUB	SI,4
; Quedan palabras?
	LOOP	OTRA_PALABRA
; En principio no, comprobar entonces si queda una ltima:
; Recuperar el resto de la divisin por dos:
	POPF
; hubo resto?
	JNC	YA_ESTA 
; S: ponerla del revs:
QUEDA_UNA_PALABRA:
CADENA_SOLO_ES_UNA_PALABRA:
	MOV	AX,[BX]
	CALL	PON_DEL_REVES_PALABRA_EN_AX
	MOV	[BX],AX
	YA_ESTA:	
        POP     SI              ; restaurar contexto y direccin cadena
	POP	DX
	POP	CX
	POP	BX
	POP	DS
	RET
PON_DEL_REVES_PALABRA_EN_AX:
	PUSH	CX		; guarda contexto del bucle externo
	MOV	CX,16
SIGUIENTE_BIT:
	RCL	AX,1
	RCR	DX,1
	LOOP	SIGUIENTE_BIT
	MOV	AX,DX
	POP	CX
	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
