CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 4
MULTIPLICA_DOBLES_PALABRAS_CON_SIGNO:
; Condicin de llamada:
;	DI:SI = Multiplicando (B1B0)
;	BX:AX = Multiplicador (A1A0)
; Condicin de retorno:
;       DI:SI:BX:AX = cudruple palabra (orden decreciente de pesos)

; Definicin de smbolos:
NEGATIVO	EQU	1
POSITIVO	EQU	0

; Comprobar el caso de la multiplicacin
	MOV	CX,DI
; Signos de los datos?
	XOR	CX,BX
	JNS	EL_PRODUCTO_ES_POSITIVO
;   Son distintos --> el producto ser negativo
	MOV	CS:PRODUCTO,NEGATIVO
; Pasar los datos a su valor absoluto:
	TEST	DI,8000h
	JNS	A_ES_NEGATIVO
B_ES_NEGATIVO:
	CALL	PASA_B_A_POSITIVO
	JMP	SHORT CONTINUA
A_ES_NEGATIVO:
; y hay que pasarlo a positivo
	CALL	PASA_A_A_POSITIVO
	JMP	SHORT CONTINUA
EL_PRODUCTO_ES_POSITIVO:
	MOV	CS:PRODUCTO,POSITIVO
; Pasar los datos a valor absoluto si es que ambos son negativos:
	TEST	BX,8000h
	JNS	CONTINUA
A_Y_B_SON_NEGATIVOS:
; y hay que pasarlos a positivo (absoluto):
	CALL	PASA_A_A_POSITIVO
	CALL	PASA_B_A_POSITIVO
CONTINUA:	
	CALL	MULTIPLICA_DOBLES_PALABRAS_SIN_SIGNO
; el producto debera ser negativo?
	DEC	CS:PRODUCTO
	JNZ	CORRECTO
;   S, pasar el resultado a negativo:
        NOT     AX
	NOT	BX
	NOT	SI
	NOT	DI
        ADD     AX,1
        ADC	BX,0
	ADC	SI,0
	ADC	DI,0
CORRECTO:	RET

PRODUCTO	DB	?

	EVEN
PASA_A_A_POSITIVO:
        NOT     AX
	NOT	BX
        ADD     AX,1
	ADC	BX,0
	RET

	EVEN
PASA_B_A_POSITIVO:
        NOT     SI
	NOT	DI
        ADD     SI,1
	ADC	DI,0
	RET

	EVEN
MULTIPLICA_DOBLES_PALABRAS_SIN_SIGNO:
; aqu el cdigo de la versin 1

; P3, P2 Y P1 <-- 0:
	MOV	CS:P1,0
	MOV	CS:P2,0
	MOV	CS:P3,0
; Guarda A0:
	MOV	CX,AX
; A0xB0:
	MUL	SI
; P0 <-- palabra baja de A0xB0 y P1 <-- palabra alta de A0xB0:
	MOV	CS:P0,AX
	MOV	CS:P1,DX
; A0xB1:
	MOV	AX,CX
	IMUL	DI
; P1 <-- P1+palabra baja de A0xB1 y P2 <-- P2+alta de A0xB1+C:
	ADD	CS:P1,AX
	ADC	CS:P2,DX
; Acumular la extensin de signo:
	XCHG	AX,DX
	CWD
	ADD	CS:P3,DX	
; Ver si hay que hacer correccin:
	TEST	CX,8000h
;     S:
	JNS	SIGUE
	ADD	CS:P2,DI
	ADC	CS:P3,0
	TEST	DI,8000h
	JNS	SIGUE
	ADD	CS:P3,0FFFFh
SIGUE:
; A1xB0:
	MOV	AX,BX
	IMUL	SI
; P1 <-- P1+palabra baja de A1xB0 y P2 <-- P2+alta de A1xB0+C:
	ADD	CS:P1,AX
	ADC	CS:P2,DX
; P3 <-- P3+extensin de signo +C:
	XCHG	AX,DX
	CWD
	ADC	CS:P3,DX
; Ver si hay que hacer correccin:
	TEST	SI,8000h
;     S:
	JNS	SIGUE2
	ADD	CS:P2,BX
	ADC	CS:P3,0
	TEST	BX,8000h
	JNS	SIGUE2
	ADD	CS:P3,0FFFFh
SIGUE2:
; A1xB1:
	MOV	AX,BX
	IMUL	DI
; P2 <-- P2+palabra baja de A1xB1 y P3 <-- P3+alta de A1xB0+C:
	ADD	CS:P2,AX
	ADC	CS:P3,DX
; Devuelve el resultado:
	MOV	DI,CS:P3
	MOV	SI,CS:P2
	MOV	BX,CS:P1
	MOV	AX,CS:P0
	RET

	EVEN
P0	DW	?
P1	DW	?
P2	DW	?
P3	DW	?

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
