CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 1
; Condicin de llamada:
;       AX= segmento de los datos de la seal
;       CX= nmero de datos de  la seal
;	DX= segmento de la tabla a crear con los picos y valles
; Se asumen desplazamientos nulos, e indicativo 0 para valle, 1 para
; pico y FFh para tabla sin picos ni valles. Cada entrada ala tabla
; se compone de un octeto para el tipo (pico o valle), otro para 
; el valor y una palabra para su ubicacin dentro del segmento.
; Condicin de salida: en DX el segmento de la tabla creada. 

VALLE		EQU	0
PICO		EQU	1

CALCULA_PICOS_Y_VALLES:
; Iniciacin:
	MOV	DS,AX
	MOV	ES,DX
	SUB	BX,BX
	SUB	DI,DI
; Marca tabla sin entradas, por si no hay ni picos ni valles:
	MOV	ES:[DI],0FFh
; suficientes muestras como para que pueda haber algn pico o valle?
	CMP	CX,3
	JB	FINAL
;   S:
; decrementar BX parea compensar el incremento de la iteracin:
	DEC	BX
IDENTIFICA_TENDENCIA:
	INC	BX
; a la entrada, se quita una iteracin porque la ltima muestra
; no se puede comparar con una siguiente.
	DEC	CX
	JCXZ	FINAL
	MOV	AL,[BX]
	CMP	AL,[BX+1]
	JE	IDENTIFICA_TENDENCIA
	JL	SIGUE_CRECIENTE
	JMP	SHORT SIGUE_DECRECIENTE
DECRECIENTE:INC	BX
; quedan datos?
	LOOP	SIGUE_DECRECRECIENTE
;    No:
FINAL:	RET
;    S: tomar  dato y compararlo con el siguiente:
SIGUE_DECRECIENTE:
	MOV	AL,[BX]
	CMP	AL,[BX+1]
; se mantiene la tendencia decreciente o igual?
	JGE	DECRECIENTE
; No;  se ha encontrado valle; guardar indicativo, valor y ubicacin:
	MOV	BYTE PTR ES:[DI],VALLE
	MOV	ES:[DI+1],AL
	MOV	ES:[DI+2],BX
        ADD     DI,4                    ; a continuacin, cambia tendencia

CRECIENTE:	
	INC	BX
; quedan datos?
	LOOP	SIGUE_CRECIENTE
;    No:
	RET
;    S: tomar dato y compararlo con el siguiente:
SIGUE_CRECIENTE:
	MOV	AL,[BX]
	CMP	AL,[BX+1]
; se  mantiene la tendencia creciente o igual?
	JLE	CRECIENTE
; No; se ha encontrado pico; guardar indicativo, valor y ubicacin:
	MOV	BYTE PTR ES:[DI],PICO
	MOV	ES:[DI+1],AL
	MOV	ES:[DI+2],BX
	ADD	DI,4
; Cambia tendencia:
	JMP	SHORT DECRECIENTE

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
