; Divisin de 32 bits entre 32 bits, con cociente de 32 bits y resto de 32 bits

PARAM   STRUC
RETORNO         DD      ?
DIVISOR_B       DW      ?
DIVISOR_A       DW      ?
DIVIDENDO_B     DW      ?
DIVIDENDO_A     DW      ?
        ENDS

; No se guarda contexto
DIVIDE_32:
; Inicia BP para acceder a los parmetros
        MOV     BP,SP
; Inicia cociente y resto a cero
        SUB     AX,AX
        SUB     DX,DX
        SUB     SI,SI
        SUB     DI,DI
;  Inicia contador del bucle con el nmero de bits de los operandos
        MOV     CX,32
; Cuerpo del bucle:
; Introduce bit del dividendo en el resto, desplazando la informacin
; a la izquierda
OTRO_BIT:
        SHL     [BP].DIVISOR_B,1
        RCL     [BP].DIVISOR_A,1
        RCL     AX,1
        RCL     DX,1
; resto mayor o igual que el dividendo?
        CMP     DX,[BP].DIVIDENDO_A
        JB      INYECTA_0               ; el acarreo est a1
        JA      INYECTA_1
        CMP     AX,[BP].DIVIDENDO_B
        JB      INYECTA_0               ; el acarreo est a 1
INYECTA_1:
; S: Resto <-- Resto - Dividendo
        SUB     AX,[BP].DIVIDENDO_B
        SBB     DX,[BP].DIVIDENDO_A     ; el acarreo queda a 0
INYECTA_0:
        CMC                             ; se complementa C para inyectar
        RLC     SI,1
        RLC     DI,1
; quedan bits?
        LOOP    OTRO_BIT
; No: FIN
        RETF    4*2     

        END
