COMMENT *
====================================================================
=                                                                  =
=            PROCEDIMIENTO QUE SUMA DATOS DE 'N' PALABRAS          =
=                             Versin 13                           =
====================================================================



Condicin de entrada: 
AX contendr el segmento en que se hallan los datos
SI es el desplazamiento del primer dato dentro del segmento especificado
CX = nmero de palabras de palabras de cada dato

Condicin de salida: 
        El resultado est en DS:SI
 	La bandera de acarreo indica si ha habido o no acarreo en la suma.*


SUMA_N_DUPLAS_PALABRAS:
		MOV	DS,AX			; inicia segmento

; BX = desplazamiento del segundo dato respecto del primero (CX x 2):
                MOV     BX,CX 
                SHL     BX,1          ; Desplazar a la izquierda multiplica x2 

; guarda el inicio del resultado (el del segundo sumando):
                MOV     AX,SI
                ADD     AX,BX
                PUSH    AX       

; BX <-- BX - 2 para compensar el incremento del ndice SI tras LODSW:
                SUB     BX,2

; ndice en modo incremento para cadenas:
                CLD

; se parte de acarreo a cero
                CLC                      
SUMA_SIGUIENTE:
                LODSW              ; SI queda apuntando al siguiente sumando B 
                ADC     [SI+BX],AX       ; [SI+BX] apunta al sumando de B
		LOOP	SUMA_SIGUIENTE
                POP     SI
                RET

