CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
BORRA_VENTANA:                  ;Versin 1
ESPACIO		EQU	20h
ATRIBUTO	EQU	07h
PATRON_DE_BORRADO	EQU	(ATRIBUTO SHL 8)+ESPACIO
SEGMENTO_DE_VIDEO	EQU	0B800h
FILAS		EQU	25
COLUMNAS	EQU	80

; Inicia segmento de vdeo, en espacio de datos:
	MOV	DI,SEGMENTO_DE_VIDEO
	MOV	DS,DI
; FILA <-- FESI:
	MOV	DH,BH
; Iteracin del bucle externo <-- FEID-FESI+1:
	MOV	DL,AH
	SUB	DL,BH
	INC	DL
; Iteracin del bucle interno <-- CEID-CESI+1
	SUB	BH,BH		; BH puede re-usarse (BL a palabra BX)
	SUB	CX,CX
	MOV	CL,AL
	SUB	CL,BL
	INC	CL
        MOV     SI,CX           ;  guarda factor de iteracin interno
BORRA_OTRA_FILA:	
        MOV     CX,SI           ; recupera factor de iteracin interno
; Inicio fila, con DI, <-- (160xFILA)+(CESIx2)=(160xFILA)+CESI+CESI
	MOV	AL,COLUMNAS*2
	MUL	DH
	ADD	AX,BX
	ADD	AX,BX
	MOV	DI,AX
; Borrar elemento en la ventana:
BORRA_ELEMENTO_DE_LA_FILA:	
	MOV	[DI],PATRON_DE_BORRADO
; Apunta al siguiente:
	ADD	DI,2
; Quedan iteraciones? (quedan elementos en la fila por borrar?)
	LOOP	BORRA_ELEMENTO_DE_LA_FILA
; NO: FILA <-- FILA+1
	INC	DH
; quedan filas por borrar?
	DEC	DL
	JNZ	BORRA_OTRA_FILA
; NO: retornar:
	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
