CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
BORRA_VENTANA:                  ;Versin 2
; Inicia segmento de vdeo, en espacio de datos:
	MOV	DI,0B800h
	MOV	DS,DI
; DH <-- FESI (se salva temporalmente porque ms adelante hace falta):
	MOV	DH,BH
; Factor de iteracin del bucle externo <-- FEID-FESI+1:
	MOV	DL,AH
	SUB	DL,BH
	INC	DL
; Factor de iteracin del bucle interno <-- CEID-CESI+1
	MOV	DH,BH		; salva FESI, que se necesita luego
	SUB	BH,BH		; BH puede re-usarse (BL a palabra BX)
	SUB	CX,CX
	MOV	CL,AL
	SUB	CL,BL
	INC	CL
        MOV     SI,CX           ;  guarda factor de iteracin interno
; Apuntar al inicio de la ventana, con DI, <-- (160xFESI)+(CESIx2)
	MOV	AL,160
        MUL     DH              ; en DH se salv FESI, que estaba en BH
	SHL	BX,1
	ADD	AX,BX
	MOV	DI,AX
; BP <-- factor de actualizacin de DI, para apuntar a siguiente lnea
	MOV     BP,160  ; BP <-- 160-((CEID-CESI+1)x2)
	SHL	CX,1
	SUB	BP,CX
	SUB	DI,BP		; para compensar el  ADD DI,BP inicial
BORRA_OTRA_FILA:
; recupera factor de iteracin del bucle interno: 
	MOV	CX,SI		
; Apuntar al  inicio de la fila, con SI, <-- SI+(160-(CEID-CESI)x2)
	ADD	DI,BP
; Borrar elemento en la ventana:
BORRA_ELEMENTO_DE_LA_FILA:	
	MOV	[DI],0720h	
; Apunta al siguiente:
	ADD	DI,2
; Quedan iteraciones? (quedan elementos en la fila por borrar?)
	LOOP	BORRA_ELEMENTO_DE_LA_FILA
; quedan filas por borrar?
	DEC	DL
	JNZ	BORRA_OTRA_FILA
; NO: retornar:
	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
