CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
TRASLADA_BLOQUE:                ; Versin 4 (no se admite un bloque nulo, 0=64K octetos)
; Descripcin: Rutina para el traslado intrasegmento de un bloque.
; Condicin de entrada:
; 	AX: segmento de origen y destino
;	SI: inicio del bloque
;	DI: inicio del destino
;       CX:  tamao del bloque a trasladar

	MOV	DS,AX		; inicia segmentos: datos para fuente
	MOV	ES,AX		; y extra para el destino
; Comprobar si el destino est entre los lmites del bloque:
	CMP	SI,DI
	JAE	RECORRIDO_ASCENDENTE2
	ADD	SI,CX		; SI <-- final del bloque
	CMP	SI,DI
	JBE	RECORRIDO_ASCENDENTE
RECORRIDO_DESCENDENTE:
	ADD	DI,CX		; DI <-- final del destino
	DEC	SI		; corrige los punteros
	DEC	DI
        STD                     ; modo decremental de los ndices
	JMP	SHORT TRASLADA
RECORRIDO_ASCENDENTE:
	SUB	SI,CX		; restaura SI con el inicio del bloque
RECORRIDO_ASCENDENTE2:
        CLD                     ; modo incremental de los ndices
TRASLADA:	
; tamao es 1?                                 ; Sustituible por:
	CMP	CX,1				;   SHR	  CX,1
	JE	TERMINA				;   JCXZ  TERMINA
; Dividir por dos el tamao del bloque:         ; 
	SHR	CX,1				;	
	
; Trasladar bloque palabra a palabra:
	REP MOVSW

; quedan un ltimo octeto por mover?
	JNC	FINAL

;       S: moverlo:
TERMINA:MOVSB
FINAL:	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
